# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define namedversion %{version}.%{reltag}

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support
%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/jboss/jaxr/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define section free

%define reltag GA

Name:           jboss-jaxr
Version:        1.2.1
Release:        5%{?dist}
Epoch:          0
Summary:        JBoss JAXR
License:        LGPLv2+
Group:          Development/Java
URL:            http://wiki.jboss.org/wiki/en/Jbossesb/JAXR
# svn -q export http://anonsvn.jboss.org/repos/jbossas/projects/jaxr/tags/jaxr-1.2.1.GA jboss-jaxr-1.2.1 && tar cjf jboss-jaxr-1.2.1.tar.bz2 jboss-jaxr-1.2.1
Source0:        jboss-jaxr-1.2.1.tar.bz2
Source1:        jboss-jaxr-jpp-depmap.xml
Source2:        jboss-jaxr-component-info.xml
Patch0:         jboss-jaxr-pom.patch
Requires(post): jpackage-utils >= 0:1.7.2
Requires(postun): jpackage-utils >= 0:1.7.2
Requires:       jboss-common-core
# FIXME: (dwalluck): juddi and ws-scout0 are bundled, not symlinked
# FIXME: (dwalluck): for building, we still need their POM files
Requires:       juddi
Requires:       ws-scout0
BuildRequires:  jboss-common-core >= 0:1.0.4
#BuildRequires:  jbossas >= 0:4.2.3
BuildRequires:  jboss5-libs
BuildRequires:  jboss-parent
# FIXME: (dwalluck): circular dependency
BuildRequires:  jbossws
BuildRequires:  jpackage-utils >= 0:1.7.2
BuildRequires:  juddi >= 0:0.9  
BuildRequires:  maven2 >= 0:2.0.4-10
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-report-maven-plugin
BuildRequires:  maven2-common-poms >= 0:1.0
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-antrun
BuildRequires:  mojo-maven2-plugin-jboss-packaging
BuildRequires:  servlet24
BuildRequires:  ws-scout0 >= 0:0.7
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The JBoss Xml Registries.

%if %with repolib
%package repolib
Summary:         Artifacts to be uploaded to a repository library
Group:           Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%patch0 -p0 -b .sav0

%{__perl} -pi -e 's|2.0.9|2.0.8|;' pom.xml

%{__mkdir} external_repo
%{__ln_s} %{_javadir} external_repo/JPP 

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
%{__mkdir_p} ${MAVEN_REPO_LOCAL}
%{_bindir}/mvn-jpp \
        -e \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        install

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}/%{name}
cp -p modules/juddi-jaxr/target/juddi-jaxr-1.2.1.GA-sources.jar %{buildroot}%{_javadir}/%{name}/juddi-jaxr-sources-%{version}.jar
cp -p modules/juddi-jaxr/target/juddi-jaxr-1.2.1.GA.jar %{buildroot}%{_javadir}/%{name}/juddi-jaxr-%{version}.jar
cp -p modules/juddi-saaj/target/juddi-saaj-1.2.1.GA-sources.jar %{buildroot}%{_javadir}/%{name}/juddi-saaj-sources-%{version}.jar
cp -p modules/juddi-saaj/target/juddi-saaj-1.2.1.GA.jar %{buildroot}%{_javadir}/%{name}/juddi-saaj-%{version}.jar
cp -p modules/juddi-service/target/juddi-service-sources.jar %{buildroot}%{_javadir}/%{name}/juddi-service-sources-%{version}.jar
cp -p modules/juddi-service/target/juddi-service.jar %{buildroot}%{_javadir}/%{name}/juddi-service-%{version}.jar
cp -p modules/juddi-service/target/juddi-service.sar %{buildroot}%{_javadir}/%{name}/juddi-service-%{version}.sar
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{version}.?ar; do %{__ln_s} ${jar} ${jar/-%{version}/}; done)

# pom
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-juddi-parent.pom
%add_to_maven_depmap org.jboss.jaxr juddi-parent %{namedversion} JPP/%{name} juddi-parent
%{__cp} -p modules/juddi-jaxr/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-juddi-jaxr.pom
%add_to_maven_depmap org.jboss.jaxr juddi-jaxr %{namedversion} JPP/%{name} juddi-jaxr
%{__cp} -p modules/juddi-saaj/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-juddi-saaj.pom
%add_to_maven_depmap org.jboss.jaxr juddi-saaj %{namedversion} JPP/%{name} juddi-saaj
%{__cp} -p modules/juddi-service/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-juddi-service.pom
%add_to_maven_depmap org.jboss.jaxr juddi-service %{namedversion} JPP/%{name} juddi-service

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%if %with repolib
%{__mkdir_p} %{buildroot}%{repodir}
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__cp} -p %{SOURCE2} %{buildroot}%{repodir}/component-info.xml
%{__sed} -i 's/@VERSION@/%{namedversion}-brew/g' %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{PATCH0} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_javadir}/%{name}/juddi-saaj.jar %{buildroot}%{repodirlib}/juddi-saaj.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}/juddi-service.jar %{buildroot}%{repodirlib}/juddi-service.jar
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif
%update_maven_depmap

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/juddi-jaxr-%{version}.jar
%{_javadir}/%{name}/juddi-jaxr-sources-%{version}.jar
%{_javadir}/%{name}/juddi-jaxr-sources.jar
%{_javadir}/%{name}/juddi-jaxr.jar
%{_javadir}/%{name}/juddi-saaj-sources-%{version}.jar
%{_javadir}/%{name}/juddi-saaj-sources.jar
%{_javadir}/%{name}/juddi-service-sources-%{version}.jar
%{_javadir}/%{name}/juddi-service-sources.jar
%{_javadir}/%{name}/juddi-saaj-%{version}.jar
%{_javadir}/%{name}/juddi-saaj.jar
%{_javadir}/%{name}/juddi-service-%{version}.jar
%{_javadir}/%{name}/juddi-service.jar
%{_javadir}/%{name}/juddi-service-%{version}.sar
%{_javadir}/%{name}/juddi-service.sar
%{_datadir}/maven2/poms/JPP.%{name}-juddi-parent.pom
%{_datadir}/maven2/poms/JPP.%{name}-juddi-jaxr.pom
%{_datadir}/maven2/poms/JPP.%{name}-juddi-saaj.pom
%{_datadir}/maven2/poms/JPP.%{name}-juddi-service.pom
%{_mavendepmapfragdir}/%{name}
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Tue Sep 21 2010 David Walluck <dwalluck@redhat.com> 0:1.2.1-5
- use jboss-common-core, not jboss-common

* Wed Mar 10 2010 David Walluck <dwalluck@redhat.com> 0:1.2.1-4
- update Requires

* Wed Nov 25 2009 David Walluck <dwalluck@redhat.com> 0:1.2.1-3
- fix depmaps

* Fri Nov 13 2009 David Walluck <dwalluck@redhat.com> 0:1.2.1-2
- fix release

* Wed Nov 11 2009 David Walluck <dwalluck@redhat.com> 1:1.2.1-1
- 1.2.1.GA

* Wed Oct 15 2008 David Walluck <dwalluck@redhat.com> 1:1.2.0-1.SP1.4
- rebuild for new juddi.jar
- remove Requires since they are bundled, not symlinked
- remove duplicate GCJ %%post
- add more strict file list

* Mon Sep 22 2008 David Walluck <dwalluck@redhat.com> 1:1.2.0-1.SP1.3
- BuildRequires: ws-scout0 and ws-scout0-repolib
- add epochs to dependencies

* Tue Sep 02 2008 David Walluck <dwalluck@redhat.com> 1:1.2.0-1.SP1.2
- add apache-scout 0.7rc2-brew as compatible
- use local jboss repository
- fix repolib directory ownership
- remove jbossws requirement

* Thu Jul 31 2008 David Walluck <dwalluck@redhat.com> 1:1.2.0-1.SP1.1
- update maven2 dependencies

* Wed Jul 30 2008 David Walluck <dwalluck@redhat.com> 1:1.2.0-1.SP1.1
- fix Release
- update License
- update BuildRoot
- GCJ fixes
- fix repolib permissions
- fix file permissions
- fix jboss-jaxr directory ownership
- fix maven directory ownership

* Tue Jul 08 2008 Permaine Cheung <pcheung@redhat.com> 1.2.0.SP1-0jpp.ep1.4
- Fix the jar/sar that go in repolib

* Wed Jun 20 2008 Yong Yang <yyang@redhat.com> 1.2.0.SP1-0jpp.ep1.2
- upgrade to SP1

* Wed Jun 18 2008 Yong Yang <yyang@redhat.com> 1.2.0.GA-0jpp.ep1.2
- Initial build
